jQuery(document).ready(function($) {
	var filter_season = '';
	var filter_division = '';
	var filter_event = '';
	var filter_player = '';

	function changeDivision() {
		filter_division = $(this).val();
		show();
	}

	function changeEvent() {
		filter_event = $(this).val();
		show();
	}

	function changePlayer() {
		filter_player = $(this).val();
		show();
	}

	function changeSeason() {
		filter_season = $(this).val();
		show();
	}

	function clickHideDetails() {
		$(this).removeClass('show');
		$(this).parent().find('.show_details').addClass('show');
		$(this).closest('div').find('.details').removeClass('show');
		return false;
	}

	function clickShowDetails() {
		$(this).removeClass('show');
		$(this).parent().find('.hide_details').addClass('show');
		$(this).closest('div').find('.details').addClass('show');
		return false;
	}

	function getTableHeader(title) {
		var html = '';
		html += '<h3>' + title + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Place';
		html += '</th>';

		html += '<th>';
		html += 'Name';
		html += '</th>';

		html += '<th>';
		html += 'PDGA#';
		html += '</th>';

		html += '<th>';
		html += 'R1';
		html += '</th>';

		html += '<th>';
		html += 'R2';
		html += '</th>';

		html += '<th>';
		html += 'R3';
		html += '</th>';

		html += '<th>';
		html += 'R4';
		html += '</th>';

		html += '<th>';
		html += 'R5';
		html += '</th>';

		html += '<th>';
		html += 'Par';
		html += '</th>';

		html += '<th>';
		html += 'Total';
		html += '</th>';

		html += '<th>';
		html += 'Winnings';
		html += '</th>';

		html += '</tr>';
		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getEventsTableHeader(title) {
		var html = '';
		html += '<h3>' + 'Events' + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Name';
		html += '</th>';

		html += '<th>';
		html += 'Course Name';
		html += '</th>';

		html += '<th>';
		html += 'Date';
		html += '</th>';

		html += '<th>';
		html += 'Players';
		html += '</th>';

		html += '</tr>';
		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}


	function show() {
		var i;
		var next;
		var place = 0;
		var row;
		var rows = window.disc_golf_event;
		var keys = Object.keys(rows);
		var html = '';
		var last_division = '-1';
		var show_events = false;
		var event_base_url = window.disc_golf_event_base_url;
		var player_base_url = window.disc_golf_player_base_url;
		var regex = new RegExp('.*' + filter_player.toLowerCase() + '.*');

		if(!rows) {
			rows = window.disc_golf_events;
			keys = Object.keys(rows);
			regex = new RegExp('.*' + filter_event.toLowerCase() + '.*');
			show_events = true;
		}

		if(show_events) {
			keys.sort();

			keys = keys.filter(function(item) {
				if(
					rows[item].season_id != 0
					&& (filter_season == '' || filter_season == rows[item].season_id)
					&& (filter_event == '' || regex.test(rows[item].event_name.toLowerCase()))
				  ) {
					  return true;
				  } else {
					  return false;
				  }
			});

			html += getEventsTableHeader();
			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];


				html += '<tr>';

				html += '<td>';
				html += '<a href="' + event_base_url + 'event=' + row.event_id + '">';
				html += row.event_name;
				html += '</a>';
				html += '</td>';

				html += '<td>';
				html += row.course_name;
				html += '</td>';

				html += '<td>';
				html += row.start_date;
				html += '</td>';

				html += '<td>';
				html += row.players;
				html += '</td>';

				html += '</tr>';

			}
			html += getTableFooter();
		} else {
			keys.sort(function(a, b) {
				if(rows[a].division_id == rows[b].division_id){
					return (rows[b].points - rows[a].points);
				} else {
					return (rows[a].division_id - rows[b].division_id);
				}
			});

			keys = keys.filter(function(item) {
				if(
					rows[item].season_id != 0
					&& (filter_season == '' || filter_season == rows[item].season_id)
					&& (filter_division == '' || filter_division == rows[item].division_id)
					&& (filter_player == '' || regex.test(rows[item].name.toLowerCase()))
				  ) {
					  return true;
				  } else {
					  return false;
				  }
			});

			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];

				if(row.division_name != last_division) {
					last_division = row.division_name;
					//console.log('getTableHeader');
					html += getTableHeader(row.division_name);
					place = 0;
				}
				place++;
				//console.log(row);

				html += '<tr>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += place;
				html += '</td>';

				html += '<td>';
				html += '<a href="' + player_base_url + 'player=' + row.player_id + '">';
				html += row.name;
				html += '</a>';
				html += '</td>';

				html += '<td>';
				html += row.pdga;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.r1;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.r2;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.r3;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.r4;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.r5;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.par;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.total;
				html += '</td>';

				html += '<td' + (row.doubles ? ' rowspan="2"' : '')  +  '>';
				html += row.winnings;
				html += '</td>';

				html += '</tr>';

				if(row.doubles) {
					html += '<tr>';

					html += '<td>';
					html += '<a href="' + player_base_url + 'player=' + row.player_id2 + '">';
					html += row.name2;
					html += '</a>';
					html += '</td>';

					html += '<td>';
					html += row.pdga2;
					html += '</td>';

					html += '</tr>';
				}


				next = i + 1;
				if(next == keys.length || rows[keys[next]].division_name != row.division_name) {
					//console.log('getTableFooter');
					html += getTableFooter();
				}
			}
		}

		$('#disc_golf_tables').html(html);
	}

	function setup() {
		var html = '';
		var i;
		var rows = window.disc_golf_event;
		var keys = Object.keys(rows);
		var last_division = '-1';
		var last_season = '-1';
		var show_events = false;

		if(!rows) {
			rows = window.disc_golf_events;
			keys = Object.keys(rows);
			show_events = true;
		}

		if(show_events) {
			keys.sort(function(a, b) {
				if(rows[a].season_name < rows[b].season_name){
					return 1;
				} else if(rows[a].season_name > rows[b].season_name){
					return -1;
				} else {
					return 0;
				}
			});

			html += 'Season: <select name="season">';
			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];
				if(row.season_id != 0 && row.season_name != last_season) {
					html += '<option value="' + row.season_id + '">' + row.season_name + '</option>';
					last_season = row.season_name;
				}
			}
			html += '</select>';

			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';

			html += 'Event: <input type="text" name="event" value="" placeholder="Search..." />';

			html += '<br>';
			html += '<br>';
		} else {
			if(rows.length == 0) {
				$('#disc_golf_event .show_details').click();
			}

			keys.sort();

			html += 'Division: <select name="division">';
			html += '<option value="">' + 'All Divisions' + '</option>';
			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];
				if(row.division_name != last_division) {
					html += '<option value="' + row.division_id + '">' + row.division_name + '</option>';
					last_division = row.division_name;
				}
			}
			html += '</select>';

			//html += '&nbsp;';
			//html += '&nbsp;';
			//html += '&nbsp;';
			//html += '&nbsp;';
			//html += '&nbsp;';

			//html += 'Player: <input type="text" name="player" value="" placeholder="Search..." />';

			html += '<br>';
			html += '<br>';
		}


		$('#disc_golf_filters').html(html);
		$('#disc_golf_filters [name=season]').change();
	}

	function init() {
		$(document).on('change', '[name=season]', changeSeason);
		$(document).on('change', '[name=division]', changeDivision);
		$(document).on('input change', '[name=player]', changePlayer);
		$(document).on('input change', '[name=event]', changeEvent);

		$(document).on('click', '.show_details', clickShowDetails);
		$(document).on('click', '.hide_details', clickHideDetails);

		setup();
		show();

		//alert(window.disc_golf_event);
	}

	init();
});
