jQuery(document).ready(function($) {
	var filter_season = '';
	var filter_event = '';

	function changeEvent() {
		filter_event = $(this).val();
		show();
	}

	function changeSeason() {
		filter_season = $(this).val();
		show();
	}

	function clickHideDetails() {
		$(this).removeClass('show');
		$(this).parent().find('.show_details').addClass('show');
		$(this).closest('div').find('.details').removeClass('show');
		return false;
	}

	function clickShowDetails() {
		$(this).removeClass('show');
		$(this).parent().find('.hide_details').addClass('show');
		$(this).closest('div').find('.details').addClass('show');
		return false;
	}

	function getEventsTableHeader(title) {
		var html = '';
		html += '<h3>' + 'Events' + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Name';
		html += '</th>';

		html += '<th>';
		html += 'Course Name';
		html += '</th>';

		html += '<th>';
		html += 'Date';
		html += '</th>';

		html += '</tr>';
		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}


	function show() {
		var i;
		var next;
		var place = 0;
		var row;
		var rows = window.disc_golf_events;
		var keys = Object.keys(rows);
		var html = '';
		var last_division = '-1';
		var event_base_url = window.disc_golf_event_base_url;
		var regex = new RegExp('.*' + filter_event.toLowerCase() + '.*');

		keys.sort();

		keys = keys.filter(function(item) {
			if(
				rows[item].season_id != 0
				&& (filter_season == '' || filter_season == rows[item].season_id)
				&& (filter_event == '' || regex.test(rows[item].event_name.toLowerCase()))
			  ) {
				  return true;
			  } else {
				  return false;
			  }
		});

		html += getEventsTableHeader();
		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];


			html += '<tr>';

			html += '<td>';
			html += '<a href="' + event_base_url + 'event=' + row.event_id + '">';
			html += row.event_name;
			html += '</a>';
			html += '</td>';

			html += '<td>';
			html += row.course_name;
			html += '</td>';

			html += '<td>';
			html += row.start_date;
			html += '</td>';

			html += '</tr>';

		}
		html += getTableFooter();

		$('#disc_golf_tables').html(html);
	}

	function setup() {
		var html = '';
		var i;
		var rows = window.disc_golf_events;
		var keys = Object.keys(rows);
		var last_division = '-1';
		var last_season = '-1';

		keys.sort(function(a, b) {
			if(rows[a].season_name > rows[b].season_name){
				return 1;
			} else if(rows[a].season_name < rows[b].season_name){
				return -1;
			} else {
				return 0;
			}
		});

		html += 'Season: <select name="season">';
		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];
			if(row.season_id != 0 && row.season_name != last_season) {
				html += '<option value="' + row.season_id + '">' + row.season_name + '</option>';
				last_season = row.season_name;
			}
		}
		html += '</select>';

		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';

		html += 'Event: <input type="text" name="event" value="" placeholder="Search..." />';

		html += '<br>';
		html += '<br>';


		$('#disc_golf_filters').html(html);
		$('#disc_golf_filters [name=season]').change();
	}

	function init() {
		$(document).on('change', '[name=season]', changeSeason);
		$(document).on('input change', '[name=event]', changeEvent);

		setup();
		show();

		//alert(window.disc_golf_event);
	}

	init();
});
