jQuery(document).ready(function($) {
	var filter_season = '';
	var filter_division = '';
	var filter_player = '';

	function changeDivision() {
		filter_division = $(this).val();
		show();
	}

	function changePlayer() {
		filter_player = $(this).val();
		show();
	}

	function changeSeason() {
		filter_season = $(this).val();
		show();
	}

	function getTableHeader(title) {
		var html = '';
		html += '<h3>' + title + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Player';
		html += '</th>';

		html += '<th>';
		html += 'PDGA#';
		html += '</th>';

		html += '<th>';
		html += 'Events';
		html += '</th>';

		html += '<th>';
		html += '1st';
		html += '</th>';

		html += '<th>';
		html += '2nd';
		html += '</th>';

		html += '<th>';
		html += '3rd';
		html += '</th>';

		html += '<th>';
		html += 'Winnings';
		html += '</th>';

		html += '</tr>';
		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}


	function show() {
		var i;
		var next;
		var row;
		var rows = window.disc_golf_data;
		var keys = Object.keys(rows);
		var html = '';
		var last_division = '-1';
		var player_base_url = window.disc_golf_player_base_url;
		var regex = new RegExp('.*' + filter_player.toLowerCase() + '.*');

		keys.sort(function(a, b) {
			if(rows[a].division_id == rows[b].division_id){
				return (rows[b].points - rows[a].points);
			} else {
				return (rows[a].division_id - rows[b].division_id);
			}
		});

		keys = keys.filter(function(item) {
			if(
				rows[item].season_id != 0
				&& (filter_season == '' || filter_season == rows[item].season_id)
				&& (filter_division == '' || filter_division == rows[item].division_id)
				&& (filter_player == '' || regex.test(rows[item].name.toLowerCase()))
			) {
				return true;
			} else {
				return false;
			}
		});

		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];

			if(row.division_name != last_division) {
				last_division = row.division_name;
				//console.log('getTableHeader');
				html += getTableHeader(row.division_name);
			}
			//console.log(row);

			html += '<tr>';
			html += '<td>';
			html += '<a href="' + player_base_url + 'player=' + row.player_id + '">';
			html += row.name;
			html += '</a>';
			html += '</td>';

			html += '<td>';
			html += row.pdga;
			html += '</td>';

			html += '<td>';
			html += row.events;
			html += '</td>';

			html += '<td>';
			html += row.first;
			html += '</td>';

			html += '<td>';
			html += row.second;
			html += '</td>';

			html += '<td>';
			html += row.third;
			html += '</td>';

			html += '<td>';
			html += row.winnings;
			html += '</td>';

			html += '</tr>';

			next = i + 1;
			if(next == keys.length || rows[keys[next]].division_name != row.division_name) {
				//console.log('getTableFooter');
				html += getTableFooter();
			}
		}

		$('#disc_golf_tables').html(html);
	}

	function setup() {
		var html = '';
		var i;
		var rows = window.disc_golf_data;
		var keys = Object.keys(rows);
		var last_division = '-1';
		var last_season = '-1';

		keys.sort(function(a, b) {
			if(rows[a].season_name < rows[b].season_name){
				return 1;
			} else if(rows[a].season_name > rows[b].season_name){
				return -1;
			} else {
				return 0;
			}
		});

		html += 'Season: <select name="season">';
		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];
			if(row.season_id != 0 && row.season_name != last_season) {
				html += '<option value="' + row.season_id + '">' + row.season_name + '</option>';
				last_season = row.season_name;
			}
		}
		html += '</select>';

		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';

		keys.sort();

		html += 'Division: <select name="division">';
		html += '<option value="">' + 'All Divisions' + '</option>';
		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];
			if(row.division_name != last_division) {
				html += '<option value="' + row.division_id + '">' + row.division_name + '</option>';
				last_division = row.division_name;
			}
		}
		html += '</select>';

		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';
		html += '&nbsp;';

		html += 'Player: <input type="text" name="player" value="" placeholder="Search..." />';

		html += '<br>';
		html += '<br>';


		$('#disc_golf_filters').html(html);
		$('#disc_golf_filters [name=season]').change();
	}

	function init() {
		$(document).on('change', '[name=season]', changeSeason);
		$(document).on('change', '[name=division]', changeDivision);
		$(document).on('input change', '[name=player]', changePlayer);
		setup();
		show();

		//alert(window.disc_golf_data);
	}

	init();
});
