jQuery(document).ready(function($) {
	var filter_season = '';
	var filter_player = '';

	function changeSeason() {
		filter_season = $(this).val();
		show();
	}

	function changePlayer() {
		filter_player = $(this).val();
		show();
	}

	function getDivisionTableHeader(title) {
		var html = '';
		html += '<h3>' + 'Divisions' + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Division';
		html += '</th>';

		html += '<th>';
		html += 'Winnings';
		html += '</th>';

		html += '<th>';
		html += 'Events';
		html += '</th>';

		html += '<th>';
		html += '1st';
		html += '</th>';

		html += '<th>';
		html += '2nd';
		html += '</th>';

		html += '<th>';
		html += '3rd';
		html += '</th>';

		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getPlayersTableHeader(title) {
		var html = '';
		html += '<h3>' + 'Players' + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Player';
		html += '</th>';

		html += '<th>';
		html += 'PDGA#';
		html += '</th>';

		html += '<th>';
		html += 'Events';
		html += '</th>';

		html += '<th>';
		html += '1st';
		html += '</th>';

		html += '<th>';
		html += '2nd';
		html += '</th>';

		html += '<th>';
		html += '3rd';
		html += '</th>';

		html += '<th>';
		html += 'Winnings';
		html += '</th>';

		html += '</tr>';
		html += '</thead>';

		html += '<tbody>';

		return html;
	}


	function getDivisionTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}

	function getEventsTableHeader(title) {
		var html = '';
		html += '<h3>' + 'Events' + '</h3>';

		html += '<table>';
		html += '<thead>';
		html += '<tr>';

		html += '<th>';
		html += 'Event';
		html += '</th>';

		html += '<th>';
		html += 'Division';
		html += '</th>';

		html += '<th>';
		html += 'Place';
		html += '</th>';

		html += '<th>';
		html += 'R1';
		html += '</th>';

		html += '<th>';
		html += 'R2';
		html += '</th>';

		html += '<th>';
		html += 'R3';
		html += '</th>';

		html += '<th>';
		html += 'R4';
		html += '</th>';

		html += '<th>';
		html += 'R5';
		html += '</th>';

		html += '<th>';
		html += 'Total';
		html += '</th>';

		html += '<th>';
		html += 'Winnings';
		html += '</th>';

		html += '</thead>';

		html += '<tbody>';

		return html;
	}

	function getEventsTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}

	function getTableFooter(title) {
		var html = '';

		html += '</tbody>';

		html += '</table>';

		return html;
	}

	function show() {
		var i;
		var next;
		var row;
		var rows = window.disc_golf_divisions;
		var rows2 = window.disc_golf_events;
		var keys = Object.keys(rows);
		var keys2 = Object.keys(rows2);
		var html = '';
		var last_division = '-1';
		var show_players = false;
		var player_base_url = window.disc_golf_player_base_url;
		var event_base_url = window.disc_golf_event_base_url;
		var regex = new RegExp('.*' + filter_player.toLowerCase() + '.*');

		if(!rows) {
			rows = window.disc_golf_players;
			keys = Object.keys(rows);
			show_players = true;
		}

		if(show_players) {
			keys.sort(function(a, b) {
				return (rows[b].points - rows[a].points);
			});

			keys = keys.filter(function(item) {
				if(
					rows[item].season_id != 0
					&& (filter_season == '' || filter_season == rows[item].season_id)
					&& (filter_player == '' || regex.test(rows[item].name.toLowerCase()))
				  ) {
					  return true;
				  } else {
					  return false;
				  }
			});

			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];

				if(i == 0) {
					html += getPlayersTableHeader(row.division_name);
				}

				html += '<tr>';
				html += '<td>';
				html += '<a href="' + player_base_url + 'player=' + row.player_id + '">';
				html += row.name;
				html += '</a>';
				html += '</td>';

				html += '<td>';
				html += row.pdga;
				html += '</td>';

				html += '<td>';
				html += row.events;
				html += '</td>';

				html += '<td>';
				html += row.first;
				html += '</td>';

				html += '<td>';
				html += row.second;
				html += '</td>';

				html += '<td>';
				html += row.third;
				html += '</td>';

				html += '<td>';
				html += row.winnings;
				html += '</td>';

				html += '</tr>';

				next = i + 1;
				if(next == keys.length) {
					//console.log('getTableFooter');
					html += getTableFooter();
				}
			}
		} else{
			keys.sort();

			html += getDivisionTableHeader();
			for(i = 0 ; i < keys.length; i++) {
				row = rows[keys[i]];
				//console.log(row);

				if(
						row.season_id != 0
						&& (filter_season == '' || filter_season == row.season_id)
				  ) {
					  html += '<tr>';
					  html += '<td>';
					  //html += '<a href="/division/?division=' + row.division_id + '">';
					  html += row.division_name;
					  //html += '</a>';
					  html += '</td>';

					  html += '<td>';
					  html += row.winnings;
					  html += '</td>';

					  html += '<td>';
					  html += row.events;
					  html += '</td>';

					  html += '<td>';
					  html += row.first;
					  html += '</td>';

					  html += '<td>';
					  html += row.second;
					  html += '</td>';

					  html += '<td>';
					  html += row.third;
					  html += '</td>';

					  html += '</tr>';

				  }
			}
			html += getDivisionTableFooter();

			//console.log(rows2);

			html += getEventsTableHeader();
			for(i = 0 ; i < keys2.length; i++) {
				row = rows2[keys2[i]];

				if(
						row.season_id != 0
						&& (filter_season == '' || filter_season == row.season_id)
				  ) {
					  html += '<tr>';
					  html += '<td>';
					  html += '<a href="' + event_base_url + 'event=' + row.event_id + '">';
					  html += row.event_name;
					  html += '</a>';
					  html += '</td>';

					  html += '<td>';
					  html += row.division_name;
					  html += '</td>';

					  html += '<td>';
					  html += row.rank;
					  html += '</td>';

					  html += '<td>';
					  html += row.r1;
					  html += '</td>';

					  html += '<td>';
					  html += row.r2;
					  html += '</td>';

					  html += '<td>';
					  html += row.r3;
					  html += '</td>';

					  html += '<td>';
					  html += row.r4;
					  html += '</td>';

					  html += '<td>';
					  html += row.r5;
					  html += '</td>';

					  html += '<td>';
					  html += row.total;
					  html += '</td>';

					  html += '<td>';
					  html += row.winnings;
					  html += '</td>';

					  html += '</tr>';

				  }
			}
			html += getEventsTableFooter();
		}

		$('#disc_golf_tables').html(html);
	}

	function setup() {
		var html = '';
		var i;
		var rows = window.disc_golf_divisions;
		var keys = Object.keys(rows);
		var last_division = '-1';
		var last_season = '-1';
		var show_players = false;

		if(!rows) {
			rows = window.disc_golf_players;
			keys = Object.keys(rows);
			show_players = true;
		}

		keys.sort(function(a, b) {
			if(rows[a].season_name < rows[b].season_name){
				return 1;
			} else if(rows[a].season_name > rows[b].season_name){
				return -1;
			} else {
				return 0;
			}
		});

		html += 'Season: <select name="season">';
		for(i = 0 ; i < keys.length; i++) {
			row = rows[keys[i]];
			if(row.season_id != 0 && row.season_name != last_season) {
				html += '<option value="' + row.season_id + '">' + row.season_name + '</option>';
				last_season = row.season_name;
			}
		}
		html += '</select>';

		if(show_players) {
			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';
			html += '&nbsp;';

			html += 'Player: <input type="text" name="player" value="" placeholder="Search..." />';
		}

		html += '<br>';
		html += '<br>';


		$('#disc_golf_filters').html(html);
		$('#disc_golf_filters [name=season]').change();
	}

	function init() {
		$(document).on('change', '[name=season]', changeSeason);
		$(document).on('input change', '[name=player]', changePlayer);
		setup();
		show();

		//alert(window.disc_golf_divisions);
	}

	init();
});
